import extend from 'extend'
import mixins from 'mixins'
import Settings from 'settings'
import Observable from 'observable'

function ChartAnimator(args) {
	this.options = extend({
		time: null,  // type Observable
		ready: null  // type Observable
	}, args);

	this.animating = false;

	this.speed = new Observable()
	this.speed.set(Settings.Preferences.get('animation_speed'))
}

ChartAnimator.prototype = extend({
	start: function() {
		console.log('start')
		this.timer = setInterval(this.bind(this.step), this.speed.value)
		this.animating = true
		this.step()
	},

	stop: function() {
		console.log('stop')
		this.timer = clearInterval(this.timer)
		this.animating = false
	},

	toggle: function() {
		console.log('toggle')
		this.animating ? this.stop() : this.start()
	},

	step: function() {
		var self = this, o = this.options

		console.log('step')

		if(o.ready.value){
			o.time.next()
		}else{
			this.timer = clearInterval(this.timer)
			o.ready.once(function(val) {
				if(!val) console.error('expected ready to be TRUE')
				if(self.animating){
					self.timer = setInterval(self.bind(self.step), self.speed.value)
					o.time.next()
				}
			})
		}
	}
}, mixins)

export default ChartAnimator
