import _Settings from 'settings'
import extend from 'extend'
import Product from 'chart/product'
import Chart from './chart'
import 'time-navigator'
import Ajaxqueue from 'ajax_queue'
import Cache from 'cache'
import Parameters from 'chart/model/parameters'
import ChartAnimator from './animator'
//import AnimationRange from 'chart/plugins/animation_range'
import loc from 'chart/model/location'
//require('tooltip/tipsy')
import './eccharts-2.css'

var Settings = _Settings.Settings
var chart
var time = new Parameters.time()
var animator

extend(Ajaxqueue.options, {cache: Cache})

Settings.data.then(function(){
	var Token = new Promise(function(resolved) {
		// TODO add token to user-info
		Ajaxqueue({
			url: '/plots/get-token/',
			dataType: 'jsonp',
			complete: function(result) {
				if(result && result.token){
					resolved(result.token)
				}else{
					console.warn('failed to get token')
				}
			}
		})
	})

	Token.then(function(token){
	var product;

	loc.set(Settings.get('last-probe-location', null))

	load_chart(function(_chart){
		(_chart && (chart = _chart.create())) || ECMWF.alert({
			title: 'Chart not found',
			content: (
				ECMWF.request.widget
				? 'Cannot find widget "<b>' + ECMWF.request.widget + '</b>"'
				: 'Chart not found: ' + product
			)
		});

		product = _chart.product

		animator = new ChartAnimator({time: time, ready: chart.ready})
		//AnimationRange()
	})

	function load_chart(done){
		var qparams = ECMWF.query()

		if(qparams && qparams.widget){
			Ajaxqueue({
				url: '/backend/get-widget/',
				json: {name: qparams.widget},
				success: function (result) {
					done(new dashboardChartDelegate(result));
				},
				error: function (result) {
				}
			});
		/*
		} else if (ECMWF.request.product) {
			done(new presetChartDelegate());
		*/
		} else {
			done(new chartDelegate());
		}
	}

	function chartDelegate() {

		this.save = function(msg) {
			Settings.set('last-product', msg.product.get_save_state());
		}

		this.create = function() {
			this.product = new Product().init({product: Settings.get('last-product', 'wind')})

			return new Chart({
				product: this.product,
				location: loc,
				time: time,
				token: token
			})
		}
	}

	function dashboardChartDelegate(widget) {

		ECMWF.request.widget = widget;

		this._title = widget.title;
		console.log('dashboardChartDelegate: widget.data:');
		console.log(widget.data);

		this.options = {
			product: widget.data.product,
			projection: widget.data.projection,
			title: '#chart-title',
			//plugins: [resize]
		}

		this.save = function (msg) {
			if (Settings.get('auto-save-widgets', false)) {
				widget.data.product = msg.product.save();
				Ajaxqueue({
					priority: 'very-high',
					url: ECMWF.options.ajax.backend.save_widget,
					json: widget,
					logErrors: 'Save product',
					success: function (result) {
						console.log('done. ', result);
					}
				});
			}
		}

		this.create = function () {
			console.log('dashboardChartDelegate.create: product=', this.options.product);
			/*
			var c = $('#chart').chart(this.options);
			$('#gadget').triggerHandler('layout');
			return c;
			*/
		}
	}

	/*
	 *  In order to speed up the initialisation of the chart, both
	 *  the loading and execution of secondary items is delayed
	 */
	require(['./stage2'])
	})
})

export default {
	chart: function(){ return chart; },
	animator: function(){ return animator; },
	time: time
}
