// see also http://viglino.github.io/ol-ext/examples/bar/map.control.bar.html
import Utils from 'utils'
import h from 'virtual-dom/h'
import './toolbar.css'
import 'menu-pane'
import LayerList from 'layer-list/2'
import Dialogue from 'dialogue'
import eccharts from 'eccharts-2'

var layers_open = false

function Toolbar(options){
	this.options = Utils.extend({
	}, options);
}

Toolbar.prototype = {

	render: function(body) {
		var self = this;
		return h('.ec-toolbar2', [
			h('div', [
				h('.layers', {
					onclick: function(){
						layers_open = !layers_open
						self.options.renderer.render()
					}
				})
			]),
			this.panels()
		])
	},

	panels: function() {
		var self = this

		if(!layers_open) return []

		if(!this.dialogue){
			this.dialogue = new Dialogue({
				renderer: this.options.renderer,
				id: 'layers-panel',
				position: {right: 0}
			})

			var chart = eccharts.chart()

			this.layer_list = new LayerList({
				renderer: this.options.renderer
			})

			this.layer_list.add_layer.subscribe(function(msg) {
				chart.product.add_layer(msg.layer_id)
			})

			this.layer_list.remove_layer.subscribe(function(msg) {
				chart.remove_layer(msg.layer_id)
			})

			this.layer_list.order.subscribe(function() {
				chart.on_layer_reorder(self.layer_list.order.lastop)
			})

			this.layer_list.modify_layer.subscribe(function() {
				console.log('layer modified')
			})

			this.layer_list.layer_options.subscribe(function() {
				console.log('layer options changed')
			})
		}

		return this.dialogue.render(this.layer_list.render())
	}
}

export default Toolbar;
